Index: trunk/src/VBox/Devices/Audio/AudioHlp.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/AudioHlp.cpp	(revision 88299)
+++ trunk/src/VBox/Devices/Audio/AudioHlp.cpp	(revision 88300)
@@ -277,5 +277,5 @@
  * will be replaced by an underscore ("_").
  *
- * @return  IPRT status code.
+ * @returns VBox status code.
  * @param   pszPath             Path to sanitize.
  * @param   cbPath              Size (in bytes) of path to sanitize.
@@ -313,5 +313,5 @@
  * Constructs an unique file name, based on the given path and the audio file type.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pszFile             Where to store the constructed file name.
  * @param   cchFile             Size (in characters) of the file name buffer.
@@ -437,5 +437,5 @@
  * Creates an audio file.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   enmType             Audio file type to open / create.
  * @param   pszFile             File path of file to open or create.
@@ -506,5 +506,5 @@
  * Opens or creates an audio file.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pFile               Pointer to audio file handle to use.
  * @param   fOpen               Open flags.
@@ -646,5 +646,5 @@
  * Closes an audio file.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pFile               Audio file handle to close.
  */
@@ -709,5 +709,5 @@
  * Deletes an audio file.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pFile               Audio file handle to delete.
  */
@@ -776,5 +776,5 @@
  * Write PCM data to a wave (.WAV) file.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pFile               Audio file handle to write PCM data to.
  * @param   pvBuf               Audio data to write.
Index: trunk/src/VBox/Devices/Audio/DevHda.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevHda.cpp	(revision 88299)
+++ trunk/src/VBox/Devices/Audio/DevHda.cpp	(revision 88300)
@@ -670,5 +670,5 @@
  * Synchronizes the CORB / RIRB buffers between internal <-> device state.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  *
  * @param   pDevIns             The device instance.
@@ -1642,5 +1642,5 @@
  * Adds an audio output stream to the device setup using the given configuration.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThisCC             The ring-3 HDA device state.
  * @param   pCfg                Stream configuration to use for adding a stream.
@@ -1765,5 +1765,5 @@
  * Adds an audio input stream to the device setup using the given configuration.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThisCC             The ring-3 HDA device state.
  * @param   pCfg                Stream configuration to use for adding a stream.
@@ -1800,5 +1800,5 @@
  * Adds an audio stream to the device setup using the given configuration.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThisCC             The ring-3 HDA device state.
  * @param   pCfg                Stream configuration to use for adding a stream.
@@ -1835,5 +1835,5 @@
  * Removes an audio stream from the device setup using the given configuration.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThisCC             The ring-3 HDA device state.
  * @param   pCfg                Stream configuration to use for removing a stream.
@@ -2184,7 +2184,7 @@
  * Adds a specific HDA driver to the driver chain.
  *
- * @return IPRT status code.
- * @param   pThisCC             The ring-3 HDA device state.
- * @param  pDrv                 HDA driver to add.
+ * @returns VBox status code.
+ * @param   pThisCC     The ring-3 HDA device state.
+ * @param   pDrv        HDA driver to add.
  */
 static int hdaR3MixerAddDrv(PHDASTATER3 pThisCC, PHDADRIVER pDrv)
@@ -2306,5 +2306,5 @@
  * Adds a driver stream to a specific mixer sink.
  *
- * @returns IPRT status code (ignored by caller).
+ * @returns VBox status code (ignored by caller).
  * @param   pMixSink            Audio mixer sink to add audio streams to.
  * @param   pCfg                Audio stream configuration to use for the audio streams to add.
@@ -2429,5 +2429,5 @@
  * Adds all current driver streams to a specific mixer sink.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThisCC             The ring-3 HDA device state.
  * @param   pMixSink            Audio mixer sink to add stream to.
Index: trunk/src/VBox/Devices/Audio/DevHdaCommon.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevHdaCommon.cpp	(revision 88299)
+++ trunk/src/VBox/Devices/Audio/DevHdaCommon.cpp	(revision 88300)
@@ -260,5 +260,5 @@
  * Converts an HDA stream's SDFMT register into a given PCM properties structure.
  *
- * @return  IPRT status code.
+ * @returns VBox status code.
  * @param   u16SDFMT            The HDA stream's SDFMT value to convert.
  * @param   pProps              PCM properties structure to hold converted result on success.
Index: trunk/src/VBox/Devices/Audio/DevHdaStream.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevHdaStream.cpp	(revision 88299)
+++ trunk/src/VBox/Devices/Audio/DevHdaStream.cpp	(revision 88300)
@@ -55,5 +55,5 @@
  * Creates an HDA stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStreamShared       The HDA stream to construct - shared bits.
  * @param   pStreamR3           The HDA stream to construct - ring-3 bits.
@@ -448,5 +448,5 @@
  * Sets up ((re-)iniitalizes) an HDA stream.
  *
- * @returns IPRT status code. VINF_NO_CHANGE if the stream does not need
+ * @returns VBox status code. VINF_NO_CHANGE if the stream does not need
  *          be set-up again because the stream's (hardware) parameters did
  *          not change.
@@ -878,5 +878,5 @@
  * Enables or disables an HDA audio stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStreamShared       HDA stream to enable or disable - shared bits.
  * @param   pStreamR3           HDA stream to enable or disable - ring-3 bits.
@@ -2277,5 +2277,5 @@
  * Locks an HDA stream for serialized access.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStreamShared       HDA stream to lock (shared bits).
  */
@@ -2292,5 +2292,5 @@
  * Unlocks a formerly locked HDA stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStreamShared       HDA stream to unlock (shared bits).
  */
@@ -2573,5 +2573,5 @@
  * Creates the async I/O thread for a specific HDA audio stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStreamR3           HDA audio stream to create the async I/O thread for.
  */
@@ -2610,5 +2610,5 @@
  * Destroys the async I/O thread of a specific HDA audio stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStreamR3           HDA audio stream to destroy the async I/O thread for.
  */
@@ -2652,5 +2652,5 @@
  * Lets the stream's async I/O thread know that there is some data to process.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStreamR3           HDA stream to notify async I/O thread for.
  */
Index: trunk/src/VBox/Devices/Audio/DevHdaStreamMap.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevHdaStreamMap.cpp	(revision 88299)
+++ trunk/src/VBox/Devices/Audio/DevHdaStreamMap.cpp	(revision 88300)
@@ -318,5 +318,5 @@
  * Initializes a stream mapping structure according to the given PCM properties.
  *
- * @return  IPRT status code.
+ * @returns VBox status code.
  * @param   pMap            Pointer to mapping to initialize.
  * @param   cHostChannels   The number of host channels to map to.
Index: trunk/src/VBox/Devices/Audio/DevIchAc97.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevIchAc97.cpp	(revision 88299)
+++ trunk/src/VBox/Devices/Audio/DevIchAc97.cpp	(revision 88300)
@@ -841,5 +841,5 @@
  * Fetches the current BDLE (Buffer Descriptor List Entry) of an AC'97 audio stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pDevIns             The device instance.
  * @param   pStream             AC'97 stream to fetch BDLE for.
@@ -951,5 +951,5 @@
  * Returns whether an AC'97 stream is enabled or not.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThisCC             The ring-3 AC'97 device state.
  * @param   pStream             Stream to return status for.
@@ -967,5 +967,5 @@
  * Enables or disables an AC'97 audio stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               The shared AC'97 state.
  * @param   pThisCC             The ring-3 AC'97 state.
@@ -1072,5 +1072,5 @@
  * Creates an AC'97 audio stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThisCC             The ring-3 AC'97 state.
  * @param   pStream             The AC'97 stream to create (shared).
@@ -1132,5 +1132,5 @@
  * Destroys an AC'97 audio stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               The shared AC'97 state.
  * @param   pStream             The AC'97 stream to destroy (shared).
@@ -1225,5 +1225,5 @@
  * Writes audio data from a mixer sink into an AC'97 stream's DMA buffer.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pDstStreamCC        The AC'97 stream to write to (ring-3).
  * @param   pSrcMixSink         Mixer sink to get audio data to write from.
@@ -1268,5 +1268,5 @@
  * Reads audio data from an AC'97 stream's DMA buffer and writes into a specified mixer sink.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pSrcStreamCC        AC'97 stream to read audio data from (ring-3).
  * @param   pDstMixSink         Mixer sink to write audio data to.
@@ -1335,5 +1335,5 @@
  * This will do the heavy lifting work for us as soon as it's getting notified by another thread.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   hThreadSelf         Thread handle.
  * @param   pvUser              User argument. Must be of type PAC97STREAMTHREADCTX.
@@ -1406,5 +1406,5 @@
  * Creates the async I/O thread for a specific AC'97 audio stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               The shared AC'97 state (shared).
  * @param   pThisCC             The shared AC'97 state (ring-3).
@@ -1463,5 +1463,5 @@
  * Lets the stream's async I/O thread know that there is some data to process.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStreamCC             The AC'97 stream to notify async I/O thread
  *                                for (ring-3).
@@ -1476,5 +1476,5 @@
  * Destroys the async I/O thread of a specific AC'97 audio stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               The shared AC'97 state.
  * @param   pStreamCC           AC'97 audio stream to destroy the async I/O thread for.
@@ -1752,5 +1752,5 @@
  * Sets a AC'97 mixer control to a specific value.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               The shared AC'97 state.
  * @param   uMixerIdx           Mixer control to set value for.
@@ -1838,5 +1838,5 @@
  * Adds a driver stream to a specific mixer sink.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pMixSink            Mixer sink to add driver stream to.
  * @param   pCfg                Stream configuration to use.
@@ -1931,5 +1931,5 @@
  * Adds all current driver streams to a specific mixer sink.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThisCC             The ring-3 AC'97 state.
  * @param   pMixSink            Mixer sink to add stream to.
@@ -1965,7 +1965,7 @@
  * Adds a specific AC'97 driver to the driver chain.
  *
- * @return IPRT status code.
- * @param  pThisCC              The ring-3 AC'97 device state.
- * @param  pDrv                 The AC'97 driver to add.
+ * @returns VBox status code.
+ * @param   pThisCC     The ring-3 AC'97 device state.
+ * @param   pDrv        The AC'97 driver to add.
  */
 static int ichac97R3MixerAddDrv(PAC97STATER3 pThisCC, PAC97DRIVER pDrv)
@@ -2127,5 +2127,5 @@
  * the last set sample rate in the AC'97 mixer for this stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               The shared AC'97 device state (shared).
  * @param   pThisCC             The shared AC'97 device state (ring-3).
@@ -2249,5 +2249,5 @@
  * Closes an AC'97 stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStream             The AC'97 stream to close (shared).
  */
@@ -2263,5 +2263,5 @@
  * side with the current AC'97 mixer settings for this stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               The shared AC'97 device state.
  * @param   pThisCC             The ring-3 AC'97 device state.
@@ -2289,5 +2289,5 @@
  * Locks an AC'97 stream for serialized access.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStreamCC           The AC'97 stream to lock (ring-3).
  */
@@ -2301,5 +2301,5 @@
  * Unlocks a formerly locked AC'97 stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pStreamCC           The AC'97 stream to unlock (ring-3).
  */
@@ -2343,5 +2343,5 @@
  * This currently only supports attenuation -- gain support is currently not implemented.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               The shared AC'97 state.
  * @param   pThisCC             The ring-3 AC'97 state.
@@ -2447,5 +2447,5 @@
  * NB: gain support is currently not implemented in PDM audio.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               The shared AC'97 state.
  * @param   pThisCC             The ring-3 AC'97 state.
@@ -2628,5 +2628,5 @@
  * Resets the AC'97 mixer.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               The shared AC'97 state.
  * @param   pThisCC             The ring-3 AC'97 state.
@@ -2800,5 +2800,5 @@
  * internal FIFO buffer and writing it as DMA data to the device.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pDevIns             The device instance.
  * @param   pThis               The shared AC'97 state.
@@ -3718,5 +3718,5 @@
  * Loads an AC'97 stream from SSM.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pDevIns             The device instance.
  * @param   pSSM                Saved state manager (SSM) handle to use.
Index: trunk/src/VBox/Devices/Audio/DevSB16.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevSB16.cpp	(revision 88299)
+++ trunk/src/VBox/Devices/Audio/DevSB16.cpp	(revision 88300)
@@ -1755,5 +1755,5 @@
  * Creates the output PDM audio stream for a specific driver.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pCfg                Stream configuration to use.
  * @param   pDrv                Driver stream to create PDM stream for.
Index: trunk/src/VBox/Devices/Audio/DrvAudio.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvAudio.cpp	(revision 88299)
+++ trunk/src/VBox/Devices/Audio/DrvAudio.cpp	(revision 88300)
@@ -2008,5 +2008,5 @@
  *       the device emulation!
  *
- * @return  IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               Driver instance to be called.
  */
Index: trunk/src/VBox/Main/src-client/AudioDriver.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/AudioDriver.cpp	(revision 88299)
+++ trunk/src/VBox/Main/src-client/AudioDriver.cpp	(revision 88300)
@@ -79,5 +79,5 @@
  * Attaches the driver via EMT, if configured.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pUVM                The user mode VM handle for talking to EMT.
  * @param   pAutoLock           The callers auto lock instance.  Can be NULL if
@@ -163,5 +163,5 @@
  * Detatches the driver via EMT, if configured.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pUVM                The user mode VM handle for talking to EMT.
  * @param   pAutoLock           The callers auto lock instance.  Can be NULL if
Index: trunk/src/VBox/Main/src-client/DrvAudioRec.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/DrvAudioRec.cpp	(revision 88299)
+++ trunk/src/VBox/Main/src-client/DrvAudioRec.cpp	(revision 88300)
@@ -296,5 +296,5 @@
  * Initializes a recording sink.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               Driver instance.
  * @param   pSink               Sink to initialize.
@@ -457,5 +457,5 @@
  * Shuts down (closes) a recording sink,
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pSink               Recording sink to shut down.
  */
@@ -499,5 +499,5 @@
  * Creates an audio output stream and associates it with the specified recording sink.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               Driver instance.
  * @param   pStreamAV           Audio output stream to create.
@@ -569,5 +569,5 @@
  * Destroys (closes) an audio output stream.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               Driver instance.
  * @param   pStreamAV           Audio output stream to destroy.
@@ -606,5 +606,5 @@
  * Controls an audio output stream
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   pThis               Driver instance.
  * @param   pStreamAV           Audio output stream to control.
@@ -1072,5 +1072,5 @@
  * Applies a video recording configuration to this driver instance.
  *
- * @returns IPRT status code.
+ * @returns VBox status code.
  * @param   Settings        Capturing configuration to apply.
  */
Index: trunk/src/VBox/Main/src-client/DrvAudioVRDE.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/DrvAudioVRDE.cpp	(revision 88299)
+++ trunk/src/VBox/Main/src-client/DrvAudioVRDE.cpp	(revision 88300)
@@ -623,5 +623,5 @@
  * RDP client.
  *
- * @return  IPRT status code.
+ * @returns VBox status code.
  * @param   pvContext               The context; in this case a pointer to a
  *                                  VRDESTREAMIN structure.