Index: trunk/src/VBox/Devices/Audio/AudioHlp.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/AudioHlp.cpp	(revision 88356)
+++ trunk/src/VBox/Devices/Audio/AudioHlp.cpp	(revision 88357)
@@ -321,8 +321,8 @@
  * @param   uInstance           Device / driver instance which is using this file.
  * @param   enmType             Audio file type to construct file name for.
- * @param   fFlags              File naming flags, PDMAUDIOFILENAME_FLAGS_XXX.
+ * @param   fFlags              File naming flags, AUDIOHLPFILENAME_FLAGS_XXX.
  */
 int AudioHlpFileNameGet(char *pszFile, size_t cchFile, const char *pszPath, const char *pszName,
-                        uint32_t uInstance, PDMAUDIOFILETYPE enmType, uint32_t fFlags)
+                        uint32_t uInstance, AUDIOHLPFILETYPE enmType, uint32_t fFlags)
 {
     AssertPtrReturn(pszFile, VERR_INVALID_POINTER);
@@ -370,5 +370,5 @@
         szFileName[0] = '\0';
 
-        if (fFlags & PDMAUDIOFILENAME_FLAGS_TS)
+        if (fFlags & AUDIOHLPFILENAME_FLAGS_TS)
         {
             RTTIMESPEC time;
@@ -404,9 +404,9 @@
         switch (enmType)
         {
-            case PDMAUDIOFILETYPE_RAW:
+            case AUDIOHLPFILETYPE_RAW:
                 rc = RTStrCat(szFileName, sizeof(szFileName), ".pcm");
                 break;
 
-            case PDMAUDIOFILETYPE_WAV:
+            case AUDIOHLPFILETYPE_WAV:
                 rc = RTStrCat(szFileName, sizeof(szFileName), ".wav");
                 break;
@@ -440,14 +440,14 @@
  * @param   enmType             Audio file type to open / create.
  * @param   pszFile             File path of file to open or create.
- * @param   fFlags              Audio file flags, PDMAUDIOFILE_FLAGS_XXX.
+ * @param   fFlags              Audio file flags, AUDIOHLPFILE_FLAGS_XXX.
  * @param   ppFile              Where to store the created audio file handle.
  *                              Needs to be destroyed with AudioHlpFileDestroy().
  */
-int AudioHlpFileCreate(PDMAUDIOFILETYPE enmType, const char *pszFile, uint32_t fFlags, PPDMAUDIOFILE *ppFile)
+int AudioHlpFileCreate(AUDIOHLPFILETYPE enmType, const char *pszFile, uint32_t fFlags, PAUDIOHLPFILE *ppFile)
 {
     AssertPtrReturn(pszFile, VERR_INVALID_POINTER);
     /** @todo Validate fFlags. */
 
-    PPDMAUDIOFILE pFile = (PPDMAUDIOFILE)RTMemAlloc(sizeof(PDMAUDIOFILE));
+    PAUDIOHLPFILE pFile = (PAUDIOHLPFILE)RTMemAlloc(sizeof(AUDIOHLPFILE));
     if (!pFile)
         return VERR_NO_MEMORY;
@@ -457,6 +457,6 @@
     switch (enmType)
     {
-        case PDMAUDIOFILETYPE_RAW:
-        case PDMAUDIOFILETYPE_WAV:
+        case AUDIOHLPFILETYPE_RAW:
+        case AUDIOHLPFILETYPE_WAV:
             pFile->enmType = enmType;
             break;
@@ -492,5 +492,5 @@
  * @param   pFile               Audio file (object) to destroy.
  */
-void AudioHlpFileDestroy(PPDMAUDIOFILE pFile)
+void AudioHlpFileDestroy(PAUDIOHLPFILE pFile)
 {
     if (!pFile)
@@ -509,8 +509,8 @@
  * @param   pFile               Pointer to audio file handle to use.
  * @param   fOpen               Open flags.
- *                              Use PDMAUDIOFILE_DEFAULT_OPEN_FLAGS for the default open flags.
+ *                              Use AUDIOHLPFILE_DEFAULT_OPEN_FLAGS for the default open flags.
  * @param   pProps              PCM properties to use.
  */
-int AudioHlpFileOpen(PPDMAUDIOFILE pFile, uint32_t fOpen, PCPDMAUDIOPCMPROPS pProps)
+int AudioHlpFileOpen(PAUDIOHLPFILE pFile, uint32_t fOpen, PCPDMAUDIOPCMPROPS pProps)
 {
     AssertPtrReturn(pFile,   VERR_INVALID_POINTER);
@@ -521,9 +521,9 @@
     int rc;
 
-    if (pFile->enmType == PDMAUDIOFILETYPE_RAW)
+    if (pFile->enmType == AUDIOHLPFILETYPE_RAW)
     {
         rc = RTFileOpen(&pFile->hFile, pFile->szName, fOpen);
     }
-    else if (pFile->enmType == PDMAUDIOFILETYPE_WAV)
+    else if (pFile->enmType == AUDIOHLPFILETYPE_WAV)
     {
         pFile->pvData = (PAUDIOWAVFILEDATA)RTMemAllocZ(sizeof(AUDIOWAVFILEDATA));
@@ -594,10 +594,10 @@
  * @param   pszName     The base filename.
  * @param   iInstance   The device/driver instance.
- * @param   fFilename   PDMAUDIOFILENAME_FLAGS_XXX.
- * @param   fCreate     PDMAUDIOFILE_FLAGS_XXX.
+ * @param   fFilename   AUDIOHLPFILENAME_FLAGS_XXX.
+ * @param   fCreate     AUDIOHLPFILE_FLAGS_XXX.
  * @param   pProps      PCM audio properties for the file.
- * @param   fOpen       RTFILE_O_XXX or PDMAUDIOFILE_DEFAULT_OPEN_FLAGS.
- */
-int AudioHlpFileCreateAndOpenEx(PPDMAUDIOFILE *ppFile, PDMAUDIOFILETYPE enmType, const char *pszDir, const char *pszName,
+ * @param   fOpen       RTFILE_O_XXX or AUDIOHLPFILE_DEFAULT_OPEN_FLAGS.
+ */
+int AudioHlpFileCreateAndOpenEx(PAUDIOHLPFILE *ppFile, AUDIOHLPFILETYPE enmType, const char *pszDir, const char *pszName,
                                 uint32_t iInstance, uint32_t fFilename, uint32_t fCreate,
                                 PCPDMAUDIOPCMPROPS pProps, uint64_t fOpen)
@@ -607,5 +607,5 @@
     if (RT_SUCCESS(rc))
     {
-        PPDMAUDIOFILE pFile = NULL;
+        PAUDIOHLPFILE pFile = NULL;
         rc = AudioHlpFileCreate(enmType, szFile, fCreate, &pFile);
         if (RT_SUCCESS(rc))
@@ -634,10 +634,10 @@
  * @param   pProps      PCM audio properties for the file.
  */
-int AudioHlpFileCreateAndOpen(PPDMAUDIOFILE *ppFile, const char *pszDir, const char *pszName,
+int AudioHlpFileCreateAndOpen(PAUDIOHLPFILE *ppFile, const char *pszDir, const char *pszName,
                               uint32_t iInstance, PCPDMAUDIOPCMPROPS pProps)
 {
-    return AudioHlpFileCreateAndOpenEx(ppFile, PDMAUDIOFILETYPE_WAV, pszDir, pszName, iInstance,
-                                       PDMAUDIOFILENAME_FLAGS_NONE, PDMAUDIOFILE_FLAGS_NONE,
-                                       pProps, PDMAUDIOFILE_DEFAULT_OPEN_FLAGS);
+    return AudioHlpFileCreateAndOpenEx(ppFile, AUDIOHLPFILETYPE_WAV, pszDir, pszName, iInstance,
+                                       AUDIOHLPFILENAME_FLAGS_NONE, AUDIOHLPFILE_FLAGS_NONE,
+                                       pProps, AUDIOHLPFILE_DEFAULT_OPEN_FLAGS);
 }
 
@@ -649,5 +649,5 @@
  * @param   pFile               Audio file handle to close.
  */
-int AudioHlpFileClose(PPDMAUDIOFILE pFile)
+int AudioHlpFileClose(PAUDIOHLPFILE pFile)
 {
     if (!pFile)
@@ -658,10 +658,10 @@
     int rc = VINF_SUCCESS;
 
-    if (pFile->enmType == PDMAUDIOFILETYPE_RAW)
+    if (pFile->enmType == AUDIOHLPFILETYPE_RAW)
     {
         if (RTFileIsValid(pFile->hFile))
             rc = RTFileClose(pFile->hFile);
     }
-    else if (pFile->enmType == PDMAUDIOFILETYPE_WAV)
+    else if (pFile->enmType == AUDIOHLPFILETYPE_WAV)
     {
         if (RTFileIsValid(pFile->hFile))
@@ -688,5 +688,5 @@
     if (   RT_SUCCESS(rc)
         && !cbSize
-        && !(pFile->fFlags & PDMAUDIOFILE_FLAGS_KEEP_IF_EMPTY))
+        && !(pFile->fFlags & AUDIOHLPFILE_FLAGS_KEEP_IF_EMPTY))
     {
         rc = AudioHlpFileDelete(pFile);
@@ -712,5 +712,5 @@
  * @param   pFile               Audio file handle to delete.
  */
-int AudioHlpFileDelete(PPDMAUDIOFILE pFile)
+int AudioHlpFileDelete(PAUDIOHLPFILE pFile)
 {
     AssertPtrReturn(pFile, VERR_INVALID_POINTER);
@@ -739,5 +739,5 @@
  * @param   pFile               Audio file handle to retrieve the audio data size for.
  */
-size_t AudioHlpFileGetDataSize(PPDMAUDIOFILE pFile)
+size_t AudioHlpFileGetDataSize(PAUDIOHLPFILE pFile)
 {
     AssertPtrReturn(pFile, 0);
@@ -745,9 +745,9 @@
     size_t cbSize = 0;
 
-    if (pFile->enmType == PDMAUDIOFILETYPE_RAW)
+    if (pFile->enmType == AUDIOHLPFILETYPE_RAW)
     {
         cbSize = RTFileTell(pFile->hFile);
     }
-    else if (pFile->enmType == PDMAUDIOFILETYPE_WAV)
+    else if (pFile->enmType == AUDIOHLPFILETYPE_WAV)
     {
         PAUDIOWAVFILEDATA pData = (PAUDIOWAVFILEDATA)pFile->pvData;
@@ -765,5 +765,5 @@
  * @param   pFile               Audio file handle to check open status for.
  */
-bool AudioHlpFileIsOpen(PPDMAUDIOFILE pFile)
+bool AudioHlpFileIsOpen(PAUDIOHLPFILE pFile)
 {
     if (!pFile)
@@ -782,5 +782,5 @@
  * @param   fFlags              Additional write flags. Not being used at the moment and must be 0.
  */
-int AudioHlpFileWrite(PPDMAUDIOFILE pFile, const void *pvBuf, size_t cbBuf, uint32_t fFlags)
+int AudioHlpFileWrite(PAUDIOHLPFILE pFile, const void *pvBuf, size_t cbBuf, uint32_t fFlags)
 {
     AssertPtrReturn(pFile, VERR_INVALID_POINTER);
@@ -796,9 +796,9 @@
     int rc;
 
-    if (pFile->enmType == PDMAUDIOFILETYPE_RAW)
+    if (pFile->enmType == AUDIOHLPFILETYPE_RAW)
     {
         rc = RTFileWrite(pFile->hFile, pvBuf, cbBuf, NULL);
     }
-    else if (pFile->enmType == PDMAUDIOFILETYPE_WAV)
+    else if (pFile->enmType == AUDIOHLPFILETYPE_WAV)
     {
         PAUDIOWAVFILEDATA pData = (PAUDIOWAVFILEDATA)pFile->pvData;
Index: trunk/src/VBox/Devices/Audio/AudioHlp.h
===================================================================
--- trunk/src/VBox/Devices/Audio/AudioHlp.h	(revision 88356)
+++ trunk/src/VBox/Devices/Audio/AudioHlp.h	(revision 88357)
@@ -48,11 +48,4 @@
 /** @}  */
 
-/** @name Audio file (name) helper methods.
- * @{ */
-int     AudioHlpFileNameSanitize(char *pszPath, size_t cbPath);
-int     AudioHlpFileNameGet(char *pszFile, size_t cchFile, const char *pszPath, const char *pszName,
-                            uint32_t uInstance, PDMAUDIOFILETYPE enmType, uint32_t fFlags);
-/** @}  */
-
 /** @name Audio string-ify methods.
  * @{ */
@@ -60,19 +53,87 @@
 /** @}  */
 
+
+/** @name AUDIOHLPFILE_FLAGS_XXX
+ * @{ */
+/** No flags defined. */
+#define AUDIOHLPFILE_FLAGS_NONE             UINT32_C(0)
+/** Keep the audio file even if it contains no audio data. */
+#define AUDIOHLPFILE_FLAGS_KEEP_IF_EMPTY    RT_BIT_32(0)
+/** Audio file flag validation mask. */
+#define AUDIOHLPFILE_FLAGS_VALID_MASK       UINT32_C(0x1)
+/** @} */
+
+/** Audio file default open flags. */
+#define AUDIOHLPFILE_DEFAULT_OPEN_FLAGS (RTFILE_O_OPEN_CREATE | RTFILE_O_APPEND | RTFILE_O_WRITE | RTFILE_O_DENY_WRITE)
+
+/**
+ * Audio file types.
+ */
+typedef enum AUDIOHLPFILETYPE
+{
+    /** The customary invalid zero value. */
+    AUDIOHLPFILETYPE_INVALID = 0,
+    /** Unknown type, do not use. */
+    AUDIOHLPFILETYPE_UNKNOWN,
+    /** Raw (PCM) file. */
+    AUDIOHLPFILETYPE_RAW,
+    /** Wave (.WAV) file. */
+    AUDIOHLPFILETYPE_WAV,
+    /** Hack to blow the type up to 32-bit. */
+    AUDIOHLPFILETYPE_32BIT_HACK = 0x7fffffff
+} AUDIOHLPFILETYPE;
+
+/** @name Audio file (name) helper methods.
+ * @{ */
+int     AudioHlpFileNameSanitize(char *pszPath, size_t cbPath);
+int     AudioHlpFileNameGet(char *pszFile, size_t cchFile, const char *pszPath, const char *pszName,
+                            uint32_t uInstance, AUDIOHLPFILETYPE enmType, uint32_t fFlags);
+/** @}  */
+
+/** @name AUDIOHLPFILENAME_FLAGS_XXX
+ * @{ */
+/** No flags defined. */
+#define AUDIOHLPFILENAME_FLAGS_NONE         UINT32_C(0)
+/** Adds an ISO timestamp to the file name. */
+#define AUDIOHLPFILENAME_FLAGS_TS           RT_BIT(0)
+/** @} */
+
+/**
+ * Audio file handle.
+ */
+typedef struct AUDIOHLPFILE
+{
+    /** Type of the audio file. */
+    AUDIOHLPFILETYPE    enmType;
+    /** Audio file flags, AUDIOHLPFILE_FLAGS_XXX. */
+    uint32_t            fFlags;
+    /** Actual file handle. */
+    RTFILE              hFile;
+    /** Data needed for the specific audio file type implemented.
+     * Optional, can be NULL. */
+    void               *pvData;
+    /** Data size (in bytes). */
+    size_t              cbData;
+    /** File name and path. */
+    char                szName[RTPATH_MAX];
+} AUDIOHLPFILE;
+/** Pointer to an audio file handle. */
+typedef AUDIOHLPFILE *PAUDIOHLPFILE;
+
 /** @name Audio file methods.
  * @{ */
-int     AudioHlpFileCreateAndOpen(PPDMAUDIOFILE *ppFile, const char *pszDir, const char *pszName,
+int     AudioHlpFileCreateAndOpen(PAUDIOHLPFILE *ppFile, const char *pszDir, const char *pszName,
                                   uint32_t iInstance, PCPDMAUDIOPCMPROPS pProps);
-int     AudioHlpFileCreateAndOpenEx(PPDMAUDIOFILE *ppFile, PDMAUDIOFILETYPE enmType, const char *pszDir, const char *pszName,
+int     AudioHlpFileCreateAndOpenEx(PAUDIOHLPFILE *ppFile, AUDIOHLPFILETYPE enmType, const char *pszDir, const char *pszName,
                                     uint32_t iInstance, uint32_t fFilename, uint32_t fCreate,
                                     PCPDMAUDIOPCMPROPS pProps, uint64_t fOpen);
-int     AudioHlpFileCreate(PDMAUDIOFILETYPE enmType, const char *pszFile, uint32_t fFlags, PPDMAUDIOFILE *ppFile);
-void    AudioHlpFileDestroy(PPDMAUDIOFILE pFile);
-int     AudioHlpFileOpen(PPDMAUDIOFILE pFile, uint32_t fOpen, PCPDMAUDIOPCMPROPS pProps);
-int     AudioHlpFileClose(PPDMAUDIOFILE pFile);
-int     AudioHlpFileDelete(PPDMAUDIOFILE pFile);
-size_t  AudioHlpFileGetDataSize(PPDMAUDIOFILE pFile);
-bool    AudioHlpFileIsOpen(PPDMAUDIOFILE pFile);
-int     AudioHlpFileWrite(PPDMAUDIOFILE pFile, const void *pvBuf, size_t cbBuf, uint32_t fFlags);
+int     AudioHlpFileCreate(AUDIOHLPFILETYPE enmType, const char *pszFile, uint32_t fFlags, PAUDIOHLPFILE *ppFile);
+void    AudioHlpFileDestroy(PAUDIOHLPFILE pFile);
+int     AudioHlpFileOpen(PAUDIOHLPFILE pFile, uint32_t fOpen, PCPDMAUDIOPCMPROPS pProps);
+int     AudioHlpFileClose(PAUDIOHLPFILE pFile);
+int     AudioHlpFileDelete(PAUDIOHLPFILE pFile);
+size_t  AudioHlpFileGetDataSize(PAUDIOHLPFILE pFile);
+bool    AudioHlpFileIsOpen(PAUDIOHLPFILE pFile);
+int     AudioHlpFileWrite(PAUDIOHLPFILE pFile, const void *pvBuf, size_t cbBuf, uint32_t fFlags);
 /** @}  */
 
Index: trunk/src/VBox/Devices/Audio/AudioMixer.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/AudioMixer.cpp	(revision 88356)
+++ trunk/src/VBox/Devices/Audio/AudioMixer.cpp	(revision 88357)
@@ -1519,10 +1519,10 @@
         char szFile[RTPATH_MAX];
         int rc2 = AudioHlpFileNameGet(szFile, RT_ELEMENTS(szFile), NULL /* Use temporary directory */, szName,
-                                      0 /* Instance */, PDMAUDIOFILETYPE_WAV, PDMAUDIOFILENAME_FLAGS_NONE);
+                                      0 /* Instance */, AUDIOHLPFILETYPE_WAV, AUDIOHLPFILENAME_FLAGS_NONE);
         if (RT_SUCCESS(rc2))
         {
-            rc2 = AudioHlpFileCreate(PDMAUDIOFILETYPE_WAV, szFile, PDMAUDIOFILE_FLAGS_NONE, &pSink->Dbg.pFile);
+            rc2 = AudioHlpFileCreate(AUDIOHLPFILETYPE_WAV, szFile, AUDIOHLPFILE_FLAGS_NONE, &pSink->Dbg.pFile);
             if (RT_SUCCESS(rc2))
-                rc2 = AudioHlpFileOpen(pSink->Dbg.pFile, PDMAUDIOFILE_DEFAULT_OPEN_FLAGS, &pSink->PCMProps);
+                rc2 = AudioHlpFileOpen(pSink->Dbg.pFile, AUDIOHLPFILE_DEFAULT_OPEN_FLAGS, &pSink->PCMProps);
         }
     }
Index: trunk/src/VBox/Devices/Audio/AudioMixer.h
===================================================================
--- trunk/src/VBox/Devices/Audio/AudioMixer.h	(revision 88356)
+++ trunk/src/VBox/Devices/Audio/AudioMixer.h	(revision 88357)
@@ -30,4 +30,5 @@
 #include <VBox/vmm/pdmaudioifs.h>
 #include "AudioMixBuffer.h"
+#include "AudioHlp.h"
 
 
@@ -236,5 +237,5 @@
     struct
     {
-        PPDMAUDIOFILE       pFile;
+        PAUDIOHLPFILE       pFile;
     } Dbg;
 } AUDMIXSINK;
Index: trunk/src/VBox/Devices/Audio/DevHdaStream.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevHdaStream.cpp	(revision 88356)
+++ trunk/src/VBox/Devices/Audio/DevHdaStream.cpp	(revision 88357)
@@ -119,8 +119,8 @@
 
         int rc2 = AudioHlpFileNameGet(szPath, sizeof(szPath), pThisCC->Dbg.pszOutPath, szFile,
-                                      0 /* uInst */, PDMAUDIOFILETYPE_WAV, PDMAUDIOFILENAME_FLAGS_NONE);
+                                      0 /* uInst */, AUDIOHLPFILETYPE_WAV, AUDIOHLPFILENAME_FLAGS_NONE);
         AssertRC(rc2);
 
-        rc2 = AudioHlpFileCreate(PDMAUDIOFILETYPE_WAV, szPath, PDMAUDIOFILE_FLAGS_NONE, &pStreamR3->Dbg.Runtime.pFileStream);
+        rc2 = AudioHlpFileCreate(AUDIOHLPFILETYPE_WAV, szPath, AUDIOHLPFILE_FLAGS_NONE, &pStreamR3->Dbg.Runtime.pFileStream);
         AssertRC(rc2);
 
@@ -132,8 +132,8 @@
 
         rc2 = AudioHlpFileNameGet(szPath, sizeof(szPath), pThisCC->Dbg.pszOutPath, szFile,
-                                  0 /* uInst */, PDMAUDIOFILETYPE_WAV, PDMAUDIOFILENAME_FLAGS_NONE);
+                                  0 /* uInst */, AUDIOHLPFILETYPE_WAV, AUDIOHLPFILENAME_FLAGS_NONE);
         AssertRC(rc2);
 
-        rc2 = AudioHlpFileCreate(PDMAUDIOFILETYPE_WAV, szPath, PDMAUDIOFILE_FLAGS_NONE, &pStreamR3->Dbg.Runtime.pFileDMARaw);
+        rc2 = AudioHlpFileCreate(AUDIOHLPFILETYPE_WAV, szPath, AUDIOHLPFILE_FLAGS_NONE, &pStreamR3->Dbg.Runtime.pFileDMARaw);
         AssertRC(rc2);
 
@@ -145,8 +145,8 @@
 
         rc2 = AudioHlpFileNameGet(szPath, sizeof(szPath), pThisCC->Dbg.pszOutPath, szFile,
-                                  0 /* uInst */, PDMAUDIOFILETYPE_WAV, PDMAUDIOFILENAME_FLAGS_NONE);
+                                  0 /* uInst */, AUDIOHLPFILETYPE_WAV, AUDIOHLPFILENAME_FLAGS_NONE);
         AssertRC(rc2);
 
-        rc2 = AudioHlpFileCreate(PDMAUDIOFILETYPE_WAV, szPath, PDMAUDIOFILE_FLAGS_NONE, &pStreamR3->Dbg.Runtime.pFileDMAMapped);
+        rc2 = AudioHlpFileCreate(AUDIOHLPFILETYPE_WAV, szPath, AUDIOHLPFILE_FLAGS_NONE, &pStreamR3->Dbg.Runtime.pFileDMAMapped);
         AssertRC(rc2);
 
@@ -916,5 +916,5 @@
             if (!AudioHlpFileIsOpen(pStreamR3->Dbg.Runtime.pFileStream))
             {
-                int rc2 = AudioHlpFileOpen(pStreamR3->Dbg.Runtime.pFileStream, PDMAUDIOFILE_DEFAULT_OPEN_FLAGS,
+                int rc2 = AudioHlpFileOpen(pStreamR3->Dbg.Runtime.pFileStream, AUDIOHLPFILE_DEFAULT_OPEN_FLAGS,
                                            &pStreamShared->State.Cfg.Props);
                 AssertRC(rc2);
@@ -923,5 +923,5 @@
             if (!AudioHlpFileIsOpen(pStreamR3->Dbg.Runtime.pFileDMARaw))
             {
-                int rc2 = AudioHlpFileOpen(pStreamR3->Dbg.Runtime.pFileDMARaw, PDMAUDIOFILE_DEFAULT_OPEN_FLAGS,
+                int rc2 = AudioHlpFileOpen(pStreamR3->Dbg.Runtime.pFileDMARaw, AUDIOHLPFILE_DEFAULT_OPEN_FLAGS,
                                            &pStreamShared->State.Cfg.Props);
                 AssertRC(rc2);
@@ -930,5 +930,5 @@
             if (!AudioHlpFileIsOpen(pStreamR3->Dbg.Runtime.pFileDMAMapped))
             {
-                int rc2 = AudioHlpFileOpen(pStreamR3->Dbg.Runtime.pFileDMAMapped, PDMAUDIOFILE_DEFAULT_OPEN_FLAGS,
+                int rc2 = AudioHlpFileOpen(pStreamR3->Dbg.Runtime.pFileDMAMapped, AUDIOHLPFILE_DEFAULT_OPEN_FLAGS,
                                            &pStreamShared->State.Cfg.Props);
                 AssertRC(rc2);
Index: trunk/src/VBox/Devices/Audio/DevHdaStream.h
===================================================================
--- trunk/src/VBox/Devices/Audio/DevHdaStream.h	(revision 88356)
+++ trunk/src/VBox/Devices/Audio/DevHdaStream.h	(revision 88357)
@@ -61,11 +61,11 @@
      *  For input streams, this dumps data being written to the device FIFO,
      *  whereas for output streams this dumps data being read from the device FIFO. */
-    R3PTRTYPE(PPDMAUDIOFILE) pFileStream;
+    R3PTRTYPE(PAUDIOHLPFILE) pFileStream;
     /** File for dumping raw DMA reads / writes.
      *  For input streams, this dumps data being written to the device DMA,
      *  whereas for output streams this dumps data being read from the device DMA. */
-    R3PTRTYPE(PPDMAUDIOFILE) pFileDMARaw;
+    R3PTRTYPE(PAUDIOHLPFILE) pFileDMARaw;
     /** File for dumping mapped (that is, extracted) DMA reads / writes. */
-    R3PTRTYPE(PPDMAUDIOFILE) pFileDMAMapped;
+    R3PTRTYPE(PAUDIOHLPFILE) pFileDMAMapped;
 } HDASTREAMDEBUGRT;
 
Index: trunk/src/VBox/Devices/Audio/DevIchAc97.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevIchAc97.cpp	(revision 88356)
+++ trunk/src/VBox/Devices/Audio/DevIchAc97.cpp	(revision 88357)
@@ -402,9 +402,9 @@
      *  For input streams, this dumps data being written to the device FIFO,
      *  whereas for output streams this dumps data being read from the device FIFO. */
-    R3PTRTYPE(PPDMAUDIOFILE)    pFileStream;
+    R3PTRTYPE(PAUDIOHLPFILE)    pFileStream;
     /** File for dumping DMA reads / writes.
      *  For input streams, this dumps data being written to the device DMA,
      *  whereas for output streams this dumps data being read from the device DMA. */
-    R3PTRTYPE(PPDMAUDIOFILE)    pFileDMA;
+    R3PTRTYPE(PAUDIOHLPFILE)    pFileDMA;
 } AC97STREAMDEBUGRT;
 
@@ -1005,5 +1005,5 @@
             if (!AudioHlpFileIsOpen(pStreamCC->Dbg.Runtime.pFileStream))
             {
-                int rc2 = AudioHlpFileOpen(pStreamCC->Dbg.Runtime.pFileStream, PDMAUDIOFILE_DEFAULT_OPEN_FLAGS,
+                int rc2 = AudioHlpFileOpen(pStreamCC->Dbg.Runtime.pFileStream, AUDIOHLPFILE_DEFAULT_OPEN_FLAGS,
                                            &pStreamCC->State.Cfg.Props);
                 AssertRC(rc2);
@@ -1012,5 +1012,5 @@
             if (!AudioHlpFileIsOpen(pStreamCC->Dbg.Runtime.pFileDMA))
             {
-                int rc2 = AudioHlpFileOpen(pStreamCC->Dbg.Runtime.pFileDMA, PDMAUDIOFILE_DEFAULT_OPEN_FLAGS,
+                int rc2 = AudioHlpFileOpen(pStreamCC->Dbg.Runtime.pFileDMA, AUDIOHLPFILE_DEFAULT_OPEN_FLAGS,
                                            &pStreamCC->State.Cfg.Props);
                 AssertRC(rc2);
@@ -1106,7 +1106,7 @@
         char szPath[RTPATH_MAX];
         int rc2 = AudioHlpFileNameGet(szPath, sizeof(szPath), pThisCC->Dbg.pszOutPath, szFile,
-                                      0 /* uInst */, PDMAUDIOFILETYPE_WAV, PDMAUDIOFILENAME_FLAGS_NONE);
+                                      0 /* uInst */, AUDIOHLPFILETYPE_WAV, AUDIOHLPFILENAME_FLAGS_NONE);
         AssertRC(rc2);
-        rc2 = AudioHlpFileCreate(PDMAUDIOFILETYPE_WAV, szPath, PDMAUDIOFILE_FLAGS_NONE, &pStreamCC->Dbg.Runtime.pFileStream);
+        rc2 = AudioHlpFileCreate(AUDIOHLPFILETYPE_WAV, szPath, AUDIOHLPFILE_FLAGS_NONE, &pStreamCC->Dbg.Runtime.pFileStream);
         AssertRC(rc2);
 
@@ -1117,8 +1117,8 @@
 
         rc2 = AudioHlpFileNameGet(szPath, sizeof(szPath), pThisCC->Dbg.pszOutPath, szFile,
-                                  0 /* uInst */, PDMAUDIOFILETYPE_WAV, PDMAUDIOFILENAME_FLAGS_NONE);
+                                  0 /* uInst */, AUDIOHLPFILETYPE_WAV, AUDIOHLPFILENAME_FLAGS_NONE);
         AssertRC(rc2);
 
-        rc2 = AudioHlpFileCreate(PDMAUDIOFILETYPE_WAV, szPath, PDMAUDIOFILE_FLAGS_NONE, &pStreamCC->Dbg.Runtime.pFileDMA);
+        rc2 = AudioHlpFileCreate(AUDIOHLPFILETYPE_WAV, szPath, AUDIOHLPFILE_FLAGS_NONE, &pStreamCC->Dbg.Runtime.pFileDMA);
         AssertRC(rc2);
 
Index: trunk/src/VBox/Devices/Audio/DrvAudio.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvAudio.cpp	(revision 88356)
+++ trunk/src/VBox/Devices/Audio/DrvAudio.cpp	(revision 88357)
@@ -141,7 +141,7 @@
             {
                 /** File for writing stream reads. */
-                PPDMAUDIOFILE   pFileStreamRead;
+                PAUDIOHLPFILE   pFileStreamRead;
                 /** File for writing non-interleaved captures. */
-                PPDMAUDIOFILE   pFileCaptureNonInterleaved;
+                PAUDIOHLPFILE   pFileCaptureNonInterleaved;
             } Dbg;
             struct
@@ -164,7 +164,7 @@
             {
                 /** File for writing stream writes. */
-                PPDMAUDIOFILE   pFileStreamWrite;
+                PAUDIOHLPFILE   pFileStreamWrite;
                 /** File for writing stream playback. */
-                PPDMAUDIOFILE   pFilePlayNonInterleaved;
+                PAUDIOHLPFILE   pFilePlayNonInterleaved;
             } Dbg;
             struct
Index: trunk/src/VBox/Devices/Audio/DrvHostAudioDebug.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DrvHostAudioDebug.cpp	(revision 88356)
+++ trunk/src/VBox/Devices/Audio/DrvHostAudioDebug.cpp	(revision 88357)
@@ -39,5 +39,5 @@
     PPDMAUDIOSTREAMCFG pCfg;
     /** Audio file to dump output to or read input from. */
-    PPDMAUDIOFILE      pFile;
+    PAUDIOHLPFILE      pFile;
     union
     {
@@ -135,8 +135,8 @@
     char szFile[RTPATH_MAX];
     int rc = AudioHlpFileNameGet(szFile, RT_ELEMENTS(szFile), NULL /* Use temporary directory */, fIn ? "DebugAudioIn" : "DebugAudioOut",
-                                 pDrv->pDrvIns->iInstance, PDMAUDIOFILETYPE_WAV, PDMAUDIOFILENAME_FLAGS_NONE);
+                                 pDrv->pDrvIns->iInstance, AUDIOHLPFILETYPE_WAV, AUDIOHLPFILENAME_FLAGS_NONE);
     if (RT_SUCCESS(rc))
     {
-        rc = AudioHlpFileCreate(PDMAUDIOFILETYPE_WAV, szFile, PDMAUDIOFILE_FLAGS_NONE, &pStreamDbg->pFile);
+        rc = AudioHlpFileCreate(AUDIOHLPFILETYPE_WAV, szFile, AUDIOHLPFILE_FLAGS_NONE, &pStreamDbg->pFile);
         if (RT_SUCCESS(rc))
             rc = AudioHlpFileOpen(pStreamDbg->pFile, RTFILE_O_WRITE | RTFILE_O_DENY_WRITE | RTFILE_O_CREATE_REPLACE, &pCfg->Props);